//  Copyright 2019 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

import 'dart:ffi';

import 'glfw_header.dart';
import 'glfw_library.dart';

GlfwInit glfwInit = Pointer<NativeFunction<GlfwInitNative>>.fromAddress(0)
    .asFunction<GlfwInit>();
GlfwTerminate glfwTerminate =
    Pointer<NativeFunction<GlfwTerminateNative>>.fromAddress(0)
        .asFunction<GlfwTerminate>();
GlfwInitHint glfwInitHint =
    Pointer<NativeFunction<GlfwInitHintNative>>.fromAddress(0)
        .asFunction<GlfwInitHint>();
GlfwGetVersion glfwGetVersion =
    Pointer<NativeFunction<GlfwGetVersionNative>>.fromAddress(0)
        .asFunction<GlfwGetVersion>();
GlfwGetVersionString glfwGetVersionString =
    Pointer<NativeFunction<GlfwGetVersionStringNative>>.fromAddress(0)
        .asFunction<GlfwGetVersionString>();
GlfwGetError glfwGetError =
    Pointer<NativeFunction<GlfwGetErrorNative>>.fromAddress(0)
        .asFunction<GlfwGetError>();
GlfwSetErrorCallback glfwSetErrorCallback =
    Pointer<NativeFunction<GlfwSetErrorCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetErrorCallback>();
GlfwGetMonitors glfwGetMonitors =
    Pointer<NativeFunction<GlfwGetMonitorsNative>>.fromAddress(0)
        .asFunction<GlfwGetMonitors>();
GlfwGetPrimaryMonitor glfwGetPrimaryMonitor =
    Pointer<NativeFunction<GlfwGetPrimaryMonitorNative>>.fromAddress(0)
        .asFunction<GlfwGetPrimaryMonitor>();
GlfwGetMonitorPos glfwGetMonitorPos =
    Pointer<NativeFunction<GlfwGetMonitorPosNative>>.fromAddress(0)
        .asFunction<GlfwGetMonitorPos>();
GlfwGetMonitorWorkarea glfwGetMonitorWorkarea =
    Pointer<NativeFunction<GlfwGetMonitorWorkareaNative>>.fromAddress(0)
        .asFunction<GlfwGetMonitorWorkarea>();
GlfwGetMonitorPhysicalSize glfwGetMonitorPhysicalSize =
    Pointer<NativeFunction<GlfwGetMonitorPhysicalSizeNative>>.fromAddress(0)
        .asFunction<GlfwGetMonitorPhysicalSize>();
GlfwGetMonitorContentScale glfwGetMonitorContentScale =
    Pointer<NativeFunction<GlfwGetMonitorContentScaleNative>>.fromAddress(0)
        .asFunction<GlfwGetMonitorContentScale>();
GlfwGetMonitorName glfwGetMonitorName =
    Pointer<NativeFunction<GlfwGetMonitorNameNative>>.fromAddress(0)
        .asFunction<GlfwGetMonitorName>();
GlfwSetMonitorUserPointer glfwSetMonitorUserPointer =
    Pointer<NativeFunction<GlfwSetMonitorUserPointerNative>>.fromAddress(0)
        .asFunction<GlfwSetMonitorUserPointer>();
GlfwGetMonitorUserPointer glfwGetMonitorUserPointer =
    Pointer<NativeFunction<GlfwGetMonitorUserPointerNative>>.fromAddress(0)
        .asFunction<GlfwGetMonitorUserPointer>();
GlfwSetMonitorCallback glfwSetMonitorCallback =
    Pointer<NativeFunction<GlfwSetMonitorCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetMonitorCallback>();
GlfwGetVideoModes glfwGetVideoModes =
    Pointer<NativeFunction<GlfwGetVideoModesNative>>.fromAddress(0)
        .asFunction<GlfwGetVideoModes>();
GlfwGetVideoMode glfwGetVideoMode =
    Pointer<NativeFunction<GlfwGetVideoModeNative>>.fromAddress(0)
        .asFunction<GlfwGetVideoMode>();
GlfwSetGamma glfwSetGamma =
    Pointer<NativeFunction<GlfwSetGammaNative>>.fromAddress(0)
        .asFunction<GlfwSetGamma>();
GlfwGetGammaRamp glfwGetGammaRamp =
    Pointer<NativeFunction<GlfwGetGammaRampNative>>.fromAddress(0)
        .asFunction<GlfwGetGammaRamp>();
GlfwSetGammaRamp glfwSetGammaRamp =
    Pointer<NativeFunction<GlfwSetGammaRampNative>>.fromAddress(0)
        .asFunction<GlfwSetGammaRamp>();
GlfwDefaultWindowHints glfwDefaultWindowHints =
    Pointer<NativeFunction<GlfwDefaultWindowHintsNative>>.fromAddress(0)
        .asFunction<GlfwDefaultWindowHints>();
GlfwWindowHint glfwWindowHint =
    Pointer<NativeFunction<GlfwWindowHintNative>>.fromAddress(0)
        .asFunction<GlfwWindowHint>();
GlfwWindowHintString glfwWindowHintString =
    Pointer<NativeFunction<GlfwWindowHintStringNative>>.fromAddress(0)
        .asFunction<GlfwWindowHintString>();
GlfwCreateWindow glfwCreateWindow =
    Pointer<NativeFunction<GlfwCreateWindowNative>>.fromAddress(0)
        .asFunction<GlfwCreateWindow>();
GlfwDestroyWindow glfwDestroyWindow =
    Pointer<NativeFunction<GlfwDestroyWindowNative>>.fromAddress(0)
        .asFunction<GlfwDestroyWindow>();
GlfwWindowShouldClose glfwWindowShouldClose =
    Pointer<NativeFunction<GlfwWindowShouldCloseNative>>.fromAddress(0)
        .asFunction<GlfwWindowShouldClose>();
GlfwSetWindowShouldClose glfwSetWindowShouldClose =
    Pointer<NativeFunction<GlfwSetWindowShouldCloseNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowShouldClose>();
GlfwSetWindowTitle glfwSetWindowTitle =
    Pointer<NativeFunction<GlfwSetWindowTitleNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowTitle>();
GlfwSetWindowIcon glfwSetWindowIcon =
    Pointer<NativeFunction<GlfwSetWindowIconNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowIcon>();
GlfwGetWindowPos glfwGetWindowPos =
    Pointer<NativeFunction<GlfwGetWindowPosNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowPos>();
GlfwSetWindowPos glfwSetWindowPos =
    Pointer<NativeFunction<GlfwSetWindowPosNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowPos>();
GlfwGetWindowSize glfwGetWindowSize =
    Pointer<NativeFunction<GlfwGetWindowSizeNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowSize>();
GlfwSetWindowSizeLimits glfwSetWindowSizeLimits =
    Pointer<NativeFunction<GlfwSetWindowSizeLimitsNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowSizeLimits>();
GlfwSetWindowAspectRatio glfwSetWindowAspectRatio =
    Pointer<NativeFunction<GlfwSetWindowAspectRatioNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowAspectRatio>();
GlfwSetWindowSize glfwSetWindowSize =
    Pointer<NativeFunction<GlfwSetWindowSizeNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowSize>();
GlfwGetFramebufferSize glfwGetFramebufferSize =
    Pointer<NativeFunction<GlfwGetFramebufferSizeNative>>.fromAddress(0)
        .asFunction<GlfwGetFramebufferSize>();
GlfwGetWindowFrameSize glfwGetWindowFrameSize =
    Pointer<NativeFunction<GlfwGetWindowFrameSizeNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowFrameSize>();
GlfwGetWindowContentScale glfwGetWindowContentScale =
    Pointer<NativeFunction<GlfwGetWindowContentScaleNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowContentScale>();
GlfwGetWindowOpacity glfwGetWindowOpacity =
    Pointer<NativeFunction<GlfwGetWindowOpacityNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowOpacity>();
GlfwSetWindowOpacity glfwSetWindowOpacity =
    Pointer<NativeFunction<GlfwSetWindowOpacityNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowOpacity>();
GlfwIconifyWindow glfwIconifyWindow =
    Pointer<NativeFunction<GlfwIconifyWindowNative>>.fromAddress(0)
        .asFunction<GlfwIconifyWindow>();
GlfwRestoreWindow glfwRestoreWindow =
    Pointer<NativeFunction<GlfwRestoreWindowNative>>.fromAddress(0)
        .asFunction<GlfwRestoreWindow>();
GlfwMaximizeWindow glfwMaximizeWindow =
    Pointer<NativeFunction<GlfwMaximizeWindowNative>>.fromAddress(0)
        .asFunction<GlfwMaximizeWindow>();
GlfwShowWindow glfwShowWindow =
    Pointer<NativeFunction<GlfwShowWindowNative>>.fromAddress(0)
        .asFunction<GlfwShowWindow>();
GlfwHideWindow glfwHideWindow =
    Pointer<NativeFunction<GlfwHideWindowNative>>.fromAddress(0)
        .asFunction<GlfwHideWindow>();
GlfwFocusWindow glfwFocusWindow =
    Pointer<NativeFunction<GlfwFocusWindowNative>>.fromAddress(0)
        .asFunction<GlfwFocusWindow>();
GlfwRequestWindowAttention glfwRequestWindowAttention =
    Pointer<NativeFunction<GlfwRequestWindowAttentionNative>>.fromAddress(0)
        .asFunction<GlfwRequestWindowAttention>();
GlfwGetWindowMonitor glfwGetWindowMonitor =
    Pointer<NativeFunction<GlfwGetWindowMonitorNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowMonitor>();
GlfwSetWindowMonitor glfwSetWindowMonitor =
    Pointer<NativeFunction<GlfwSetWindowMonitorNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowMonitor>();
GlfwGetWindowAttrib glfwGetWindowAttrib =
    Pointer<NativeFunction<GlfwGetWindowAttribNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowAttrib>();
GlfwSetWindowAttrib glfwSetWindowAttrib =
    Pointer<NativeFunction<GlfwSetWindowAttribNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowAttrib>();
GlfwSetWindowUserPointer glfwSetWindowUserPointer =
    Pointer<NativeFunction<GlfwSetWindowUserPointerNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowUserPointer>();
GlfwGetWindowUserPointer glfwGetWindowUserPointer =
    Pointer<NativeFunction<GlfwGetWindowUserPointerNative>>.fromAddress(0)
        .asFunction<GlfwGetWindowUserPointer>();
GlfwSetWindowPosCallback glfwSetWindowPosCallback =
    Pointer<NativeFunction<GlfwSetWindowPosCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowPosCallback>();
GlfwSetWindowSizeCallback glfwSetWindowSizeCallback =
    Pointer<NativeFunction<GlfwSetWindowSizeCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowSizeCallback>();
GlfwSetWindowCloseCallback glfwSetWindowCloseCallback =
    Pointer<NativeFunction<GlfwSetWindowCloseCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowCloseCallback>();
GlfwSetWindowRefreshCallback glfwSetWindowRefreshCallback =
    Pointer<NativeFunction<GlfwSetWindowRefreshCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowRefreshCallback>();
GlfwSetWindowFocusCallback glfwSetWindowFocusCallback =
    Pointer<NativeFunction<GlfwSetWindowFocusCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowFocusCallback>();
GlfwSetWindowIconifyCallback glfwSetWindowIconifyCallback =
    Pointer<NativeFunction<GlfwSetWindowIconifyCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowIconifyCallback>();
GlfwSetWindowMaximizeCallback glfwSetWindowMaximizeCallback =
    Pointer<NativeFunction<GlfwSetWindowMaximizeCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetWindowMaximizeCallback>();
GlfwSetFramebufferSizeCallback glfwSetFramebufferSizeCallback =
    Pointer<NativeFunction<GlfwSetFramebufferSizeCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetFramebufferSizeCallback>();
GlfwSetWindowContentScaleCallback glfwSetWindowContentScaleCallback = Pointer<
        NativeFunction<GlfwSetWindowContentScaleCallbackNative>>.fromAddress(0)
    .asFunction<GlfwSetWindowContentScaleCallback>();
GlfwPollEvents glfwPollEvents =
    Pointer<NativeFunction<GlfwPollEventsNative>>.fromAddress(0)
        .asFunction<GlfwPollEvents>();
GlfwWaitEvents glfwWaitEvents =
    Pointer<NativeFunction<GlfwWaitEventsNative>>.fromAddress(0)
        .asFunction<GlfwWaitEvents>();
GlfwWaitEventsTimeout glfwWaitEventsTimeout =
    Pointer<NativeFunction<GlfwWaitEventsTimeoutNative>>.fromAddress(0)
        .asFunction<GlfwWaitEventsTimeout>();
GlfwPostEmptyEvent glfwPostEmptyEvent =
    Pointer<NativeFunction<GlfwPostEmptyEventNative>>.fromAddress(0)
        .asFunction<GlfwPostEmptyEvent>();
GlfwGetInputMode glfwGetInputMode =
    Pointer<NativeFunction<GlfwGetInputModeNative>>.fromAddress(0)
        .asFunction<GlfwGetInputMode>();
GlfwSetInputMode glfwSetInputMode =
    Pointer<NativeFunction<GlfwSetInputModeNative>>.fromAddress(0)
        .asFunction<GlfwSetInputMode>();
GlfwRawMouseMotionSupported glfwRawMouseMotionSupported =
    Pointer<NativeFunction<GlfwRawMouseMotionSupportedNative>>.fromAddress(0)
        .asFunction<GlfwRawMouseMotionSupported>();
GlfwGetKeyName glfwGetKeyName =
    Pointer<NativeFunction<GlfwGetKeyNameNative>>.fromAddress(0)
        .asFunction<GlfwGetKeyName>();
GlfwGetKeyScancode glfwGetKeyScancode =
    Pointer<NativeFunction<GlfwGetKeyScancodeNative>>.fromAddress(0)
        .asFunction<GlfwGetKeyScancode>();
GlfwGetKey glfwGetKey = Pointer<NativeFunction<GlfwGetKeyNative>>.fromAddress(0)
    .asFunction<GlfwGetKey>();
GlfwGetMouseButton glfwGetMouseButton =
    Pointer<NativeFunction<GlfwGetMouseButtonNative>>.fromAddress(0)
        .asFunction<GlfwGetMouseButton>();
GlfwGetCursorPos glfwGetCursorPos =
    Pointer<NativeFunction<GlfwGetCursorPosNative>>.fromAddress(0)
        .asFunction<GlfwGetCursorPos>();
GlfwSetCursorPos glfwSetCursorPos =
    Pointer<NativeFunction<GlfwSetCursorPosNative>>.fromAddress(0)
        .asFunction<GlfwSetCursorPos>();
GlfwCreateCursor glfwCreateCursor =
    Pointer<NativeFunction<GlfwCreateCursorNative>>.fromAddress(0)
        .asFunction<GlfwCreateCursor>();
GlfwCreateStandardCursor glfwCreateStandardCursor =
    Pointer<NativeFunction<GlfwCreateStandardCursorNative>>.fromAddress(0)
        .asFunction<GlfwCreateStandardCursor>();
GlfwDestroyCursor glfwDestroyCursor =
    Pointer<NativeFunction<GlfwDestroyCursorNative>>.fromAddress(0)
        .asFunction<GlfwDestroyCursor>();
GlfwSetCursor glfwSetCursor =
    Pointer<NativeFunction<GlfwSetCursorNative>>.fromAddress(0)
        .asFunction<GlfwSetCursor>();
GlfwSetKeyCallback glfwSetKeyCallback =
    Pointer<NativeFunction<GlfwSetKeyCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetKeyCallback>();
GlfwSetCharCallback glfwSetCharCallback =
    Pointer<NativeFunction<GlfwSetCharCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetCharCallback>();
GlfwSetCharModsCallback glfwSetCharModsCallback =
    Pointer<NativeFunction<GlfwSetCharModsCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetCharModsCallback>();
GlfwSetMouseButtonCallback glfwSetMouseButtonCallback =
    Pointer<NativeFunction<GlfwSetMouseButtonCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetMouseButtonCallback>();
GlfwSetCursorPosCallback glfwSetCursorPosCallback =
    Pointer<NativeFunction<GlfwSetCursorPosCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetCursorPosCallback>();
GlfwSetCursorEnterCallback glfwSetCursorEnterCallback =
    Pointer<NativeFunction<GlfwSetCursorEnterCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetCursorEnterCallback>();
GlfwSetScrollCallback glfwSetScrollCallback =
    Pointer<NativeFunction<GlfwSetScrollCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetScrollCallback>();
GlfwSetDropCallback glfwSetDropCallback =
    Pointer<NativeFunction<GlfwSetDropCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetDropCallback>();
GlfwJoystickPresent glfwJoystickPresent =
    Pointer<NativeFunction<GlfwJoystickPresentNative>>.fromAddress(0)
        .asFunction<GlfwJoystickPresent>();
GlfwGetJoystickAxes glfwGetJoystickAxes =
    Pointer<NativeFunction<GlfwGetJoystickAxesNative>>.fromAddress(0)
        .asFunction<GlfwGetJoystickAxes>();
GlfwGetJoystickButtons glfwGetJoystickButtons =
    Pointer<NativeFunction<GlfwGetJoystickButtonsNative>>.fromAddress(0)
        .asFunction<GlfwGetJoystickButtons>();
GlfwGetJoystickHats glfwGetJoystickHats =
    Pointer<NativeFunction<GlfwGetJoystickHatsNative>>.fromAddress(0)
        .asFunction<GlfwGetJoystickHats>();
GlfwGetJoystickName glfwGetJoystickName =
    Pointer<NativeFunction<GlfwGetJoystickNameNative>>.fromAddress(0)
        .asFunction<GlfwGetJoystickName>();
GlfwGetJoystickGUID glfwGetJoystickGUID =
    Pointer<NativeFunction<GlfwGetJoystickGUIDNative>>.fromAddress(0)
        .asFunction<GlfwGetJoystickGUID>();
GlfwSetJoystickUserPointer glfwSetJoystickUserPointer =
    Pointer<NativeFunction<GlfwSetJoystickUserPointerNative>>.fromAddress(0)
        .asFunction<GlfwSetJoystickUserPointer>();
GlfwGetJoystickUserPointer glfwGetJoystickUserPointer =
    Pointer<NativeFunction<GlfwGetJoystickUserPointerNative>>.fromAddress(0)
        .asFunction<GlfwGetJoystickUserPointer>();
GlfwJoystickIsGamepad glfwJoystickIsGamepad =
    Pointer<NativeFunction<GlfwJoystickIsGamepadNative>>.fromAddress(0)
        .asFunction<GlfwJoystickIsGamepad>();
GlfwSetJoystickCallback glfwSetJoystickCallback =
    Pointer<NativeFunction<GlfwSetJoystickCallbackNative>>.fromAddress(0)
        .asFunction<GlfwSetJoystickCallback>();
GlfwUpdateGamepadMappings glfwUpdateGamepadMappings =
    Pointer<NativeFunction<GlfwUpdateGamepadMappingsNative>>.fromAddress(0)
        .asFunction<GlfwUpdateGamepadMappings>();
GlfwGetGamepadName glfwGetGamepadName =
    Pointer<NativeFunction<GlfwGetGamepadNameNative>>.fromAddress(0)
        .asFunction<GlfwGetGamepadName>();
GlfwGetGamepadState glfwGetGamepadState =
    Pointer<NativeFunction<GlfwGetGamepadStateNative>>.fromAddress(0)
        .asFunction<GlfwGetGamepadState>();
GlfwSetClipboardString glfwSetClipboardString =
    Pointer<NativeFunction<GlfwSetClipboardStringNative>>.fromAddress(0)
        .asFunction<GlfwSetClipboardString>();
GlfwGetClipboardString glfwGetClipboardString =
    Pointer<NativeFunction<GlfwGetClipboardStringNative>>.fromAddress(0)
        .asFunction<GlfwGetClipboardString>();
GlfwGetTime glfwGetTime =
    Pointer<NativeFunction<GlfwGetTimeNative>>.fromAddress(0)
        .asFunction<GlfwGetTime>();
GlfwSetTime glfwSetTime =
    Pointer<NativeFunction<GlfwSetTimeNative>>.fromAddress(0)
        .asFunction<GlfwSetTime>();
GlfwGetTimerValue glfwGetTimerValue =
    Pointer<NativeFunction<GlfwGetTimerValueNative>>.fromAddress(0)
        .asFunction<GlfwGetTimerValue>();
GlfwGetTimerFrequency glfwGetTimerFrequency =
    Pointer<NativeFunction<GlfwGetTimerFrequencyNative>>.fromAddress(0)
        .asFunction<GlfwGetTimerFrequency>();
GlfwMakeContextCurrent glfwMakeContextCurrent =
    Pointer<NativeFunction<GlfwMakeContextCurrentNative>>.fromAddress(0)
        .asFunction<GlfwMakeContextCurrent>();
GlfwGetCurrentContext glfwGetCurrentContext =
    Pointer<NativeFunction<GlfwGetCurrentContextNative>>.fromAddress(0)
        .asFunction<GlfwGetCurrentContext>();
GlfwSwapBuffers glfwSwapBuffers =
    Pointer<NativeFunction<GlfwSwapBuffersNative>>.fromAddress(0)
        .asFunction<GlfwSwapBuffers>();
GlfwSwapInterval glfwSwapInterval =
    Pointer<NativeFunction<GlfwSwapIntervalNative>>.fromAddress(0)
        .asFunction<GlfwSwapInterval>();
GlfwExtensionSupported glfwExtensionSupported =
    Pointer<NativeFunction<GlfwExtensionSupportedNative>>.fromAddress(0)
        .asFunction<GlfwExtensionSupported>();
GlfwGetProcAddress glfwGetProcAddress =
    Pointer<NativeFunction<GlfwGetProcAddressNative>>.fromAddress(0)
        .asFunction<GlfwGetProcAddress>();
GlfwVulkanSupported glfwVulkanSupported =
    Pointer<NativeFunction<GlfwVulkanSupportedNative>>.fromAddress(0)
        .asFunction<GlfwVulkanSupported>();
GlfwGetRequiredInstanceExtensions glfwGetRequiredInstanceExtensions = Pointer<
        NativeFunction<GlfwGetRequiredInstanceExtensionsNative>>.fromAddress(0)
    .asFunction<GlfwGetRequiredInstanceExtensions>();
GlfwGetInstanceProcAddress glfwGetInstanceProcAddress =
    Pointer<NativeFunction<GlfwGetInstanceProcAddressNative>>.fromAddress(0)
        .asFunction<GlfwGetInstanceProcAddress>();
GlfwGetPhysicalDevicePresentationSupport
    glfwGetPhysicalDevicePresentationSupport = Pointer<
            NativeFunction<
                GlfwGetPhysicalDevicePresentationSupportNative>>.fromAddress(0)
        .asFunction<GlfwGetPhysicalDevicePresentationSupport>();
GlfwCreateWindowSurface glfwCreateWindowSurface =
    Pointer<NativeFunction<GlfwCreateWindowSurfaceNative>>.fromAddress(0)
        .asFunction<GlfwCreateWindowSurface>();

void initGlfw() {
  final lib = loadLibrary();

  glfwInit =
      loadFunction<GlfwInitNative>(lib, 'glfwInit').asFunction<GlfwInit>();
  glfwTerminate = loadFunction<GlfwTerminateNative>(lib, 'glfwTerminate')
      .asFunction<GlfwTerminate>();
  glfwInitHint = loadFunction<GlfwInitHintNative>(lib, 'glfwInitHint')
      .asFunction<GlfwInitHint>();
  glfwGetVersion = loadFunction<GlfwGetVersionNative>(lib, 'glfwGetVersion')
      .asFunction<GlfwGetVersion>();
  glfwGetVersionString =
      loadFunction<GlfwGetVersionStringNative>(lib, 'glfwGetVersionString')
          .asFunction<GlfwGetVersionString>();
  glfwGetError = loadFunction<GlfwGetErrorNative>(lib, 'glfwGetError')
      .asFunction<GlfwGetError>();
  glfwSetErrorCallback =
      loadFunction<GlfwSetErrorCallbackNative>(lib, 'glfwSetErrorCallback')
          .asFunction<GlfwSetErrorCallback>();
  glfwGetMonitors = loadFunction<GlfwGetMonitorsNative>(lib, 'glfwGetMonitors')
      .asFunction<GlfwGetMonitors>();
  glfwGetPrimaryMonitor =
      loadFunction<GlfwGetPrimaryMonitorNative>(lib, 'glfwGetPrimaryMonitor')
          .asFunction<GlfwGetPrimaryMonitor>();
  glfwGetMonitorPos =
      loadFunction<GlfwGetMonitorPosNative>(lib, 'glfwGetMonitorPos')
          .asFunction<GlfwGetMonitorPos>();
  glfwGetMonitorWorkarea =
      loadFunction<GlfwGetMonitorWorkareaNative>(lib, 'glfwGetMonitorWorkarea')
          .asFunction<GlfwGetMonitorWorkarea>();
  glfwGetMonitorPhysicalSize = loadFunction<GlfwGetMonitorPhysicalSizeNative>(
          lib, 'glfwGetMonitorPhysicalSize')
      .asFunction<GlfwGetMonitorPhysicalSize>();
  glfwGetMonitorContentScale = loadFunction<GlfwGetMonitorContentScaleNative>(
          lib, 'glfwGetMonitorContentScale')
      .asFunction<GlfwGetMonitorContentScale>();
  glfwGetMonitorName =
      loadFunction<GlfwGetMonitorNameNative>(lib, 'glfwGetMonitorName')
          .asFunction<GlfwGetMonitorName>();
  glfwSetMonitorUserPointer = loadFunction<GlfwSetMonitorUserPointerNative>(
          lib, 'glfwSetMonitorUserPointer')
      .asFunction<GlfwSetMonitorUserPointer>();
  glfwGetMonitorUserPointer = loadFunction<GlfwGetMonitorUserPointerNative>(
          lib, 'glfwGetMonitorUserPointer')
      .asFunction<GlfwGetMonitorUserPointer>();
  glfwSetMonitorCallback =
      loadFunction<GlfwSetMonitorCallbackNative>(lib, 'glfwSetMonitorCallback')
          .asFunction<GlfwSetMonitorCallback>();
  glfwGetVideoModes =
      loadFunction<GlfwGetVideoModesNative>(lib, 'glfwGetVideoModes')
          .asFunction<GlfwGetVideoModes>();
  glfwGetVideoMode =
      loadFunction<GlfwGetVideoModeNative>(lib, 'glfwGetVideoMode')
          .asFunction<GlfwGetVideoMode>();
  glfwSetGamma = loadFunction<GlfwSetGammaNative>(lib, 'glfwSetGamma')
      .asFunction<GlfwSetGamma>();
  glfwGetGammaRamp =
      loadFunction<GlfwGetGammaRampNative>(lib, 'glfwGetGammaRamp')
          .asFunction<GlfwGetGammaRamp>();
  glfwSetGammaRamp =
      loadFunction<GlfwSetGammaRampNative>(lib, 'glfwSetGammaRamp')
          .asFunction<GlfwSetGammaRamp>();
  glfwDefaultWindowHints =
      loadFunction<GlfwDefaultWindowHintsNative>(lib, 'glfwDefaultWindowHints')
          .asFunction<GlfwDefaultWindowHints>();
  glfwWindowHint = loadFunction<GlfwWindowHintNative>(lib, 'glfwWindowHint')
      .asFunction<GlfwWindowHint>();
  glfwWindowHintString =
      loadFunction<GlfwWindowHintStringNative>(lib, 'glfwWindowHintString')
          .asFunction<GlfwWindowHintString>();
  glfwCreateWindow =
      loadFunction<GlfwCreateWindowNative>(lib, 'glfwCreateWindow')
          .asFunction<GlfwCreateWindow>();
  glfwDestroyWindow =
      loadFunction<GlfwDestroyWindowNative>(lib, 'glfwDestroyWindow')
          .asFunction<GlfwDestroyWindow>();
  glfwWindowShouldClose =
      loadFunction<GlfwWindowShouldCloseNative>(lib, 'glfwWindowShouldClose')
          .asFunction<GlfwWindowShouldClose>();
  glfwSetWindowShouldClose = loadFunction<GlfwSetWindowShouldCloseNative>(
          lib, 'glfwSetWindowShouldClose')
      .asFunction<GlfwSetWindowShouldClose>();
  glfwSetWindowTitle =
      loadFunction<GlfwSetWindowTitleNative>(lib, 'glfwSetWindowTitle')
          .asFunction<GlfwSetWindowTitle>();
  glfwSetWindowIcon =
      loadFunction<GlfwSetWindowIconNative>(lib, 'glfwSetWindowIcon')
          .asFunction<GlfwSetWindowIcon>();
  glfwGetWindowPos =
      loadFunction<GlfwGetWindowPosNative>(lib, 'glfwGetWindowPos')
          .asFunction<GlfwGetWindowPos>();
  glfwSetWindowPos =
      loadFunction<GlfwSetWindowPosNative>(lib, 'glfwSetWindowPos')
          .asFunction<GlfwSetWindowPos>();
  glfwGetWindowSize =
      loadFunction<GlfwGetWindowSizeNative>(lib, 'glfwGetWindowSize')
          .asFunction<GlfwGetWindowSize>();
  glfwSetWindowSizeLimits = loadFunction<GlfwSetWindowSizeLimitsNative>(
          lib, 'glfwSetWindowSizeLimits')
      .asFunction<GlfwSetWindowSizeLimits>();
  glfwSetWindowAspectRatio = loadFunction<GlfwSetWindowAspectRatioNative>(
          lib, 'glfwSetWindowAspectRatio')
      .asFunction<GlfwSetWindowAspectRatio>();
  glfwSetWindowSize =
      loadFunction<GlfwSetWindowSizeNative>(lib, 'glfwSetWindowSize')
          .asFunction<GlfwSetWindowSize>();
  glfwGetFramebufferSize =
      loadFunction<GlfwGetFramebufferSizeNative>(lib, 'glfwGetFramebufferSize')
          .asFunction<GlfwGetFramebufferSize>();
  glfwGetWindowFrameSize =
      loadFunction<GlfwGetWindowFrameSizeNative>(lib, 'glfwGetWindowFrameSize')
          .asFunction<GlfwGetWindowFrameSize>();
  glfwGetWindowContentScale = loadFunction<GlfwGetWindowContentScaleNative>(
          lib, 'glfwGetWindowContentScale')
      .asFunction<GlfwGetWindowContentScale>();
  glfwGetWindowOpacity =
      loadFunction<GlfwGetWindowOpacityNative>(lib, 'glfwGetWindowOpacity')
          .asFunction<GlfwGetWindowOpacity>();
  glfwSetWindowOpacity =
      loadFunction<GlfwSetWindowOpacityNative>(lib, 'glfwSetWindowOpacity')
          .asFunction<GlfwSetWindowOpacity>();
  glfwIconifyWindow =
      loadFunction<GlfwIconifyWindowNative>(lib, 'glfwIconifyWindow')
          .asFunction<GlfwIconifyWindow>();
  glfwRestoreWindow =
      loadFunction<GlfwRestoreWindowNative>(lib, 'glfwRestoreWindow')
          .asFunction<GlfwRestoreWindow>();
  glfwMaximizeWindow =
      loadFunction<GlfwMaximizeWindowNative>(lib, 'glfwMaximizeWindow')
          .asFunction<GlfwMaximizeWindow>();
  glfwShowWindow = loadFunction<GlfwShowWindowNative>(lib, 'glfwShowWindow')
      .asFunction<GlfwShowWindow>();
  glfwHideWindow = loadFunction<GlfwHideWindowNative>(lib, 'glfwHideWindow')
      .asFunction<GlfwHideWindow>();
  glfwFocusWindow = loadFunction<GlfwFocusWindowNative>(lib, 'glfwFocusWindow')
      .asFunction<GlfwFocusWindow>();
  glfwRequestWindowAttention = loadFunction<GlfwRequestWindowAttentionNative>(
          lib, 'glfwRequestWindowAttention')
      .asFunction<GlfwRequestWindowAttention>();
  glfwGetWindowMonitor =
      loadFunction<GlfwGetWindowMonitorNative>(lib, 'glfwGetWindowMonitor')
          .asFunction<GlfwGetWindowMonitor>();
  glfwSetWindowMonitor =
      loadFunction<GlfwSetWindowMonitorNative>(lib, 'glfwSetWindowMonitor')
          .asFunction<GlfwSetWindowMonitor>();
  glfwGetWindowAttrib =
      loadFunction<GlfwGetWindowAttribNative>(lib, 'glfwGetWindowAttrib')
          .asFunction<GlfwGetWindowAttrib>();
  glfwSetWindowAttrib =
      loadFunction<GlfwSetWindowAttribNative>(lib, 'glfwSetWindowAttrib')
          .asFunction<GlfwSetWindowAttrib>();
  glfwSetWindowUserPointer = loadFunction<GlfwSetWindowUserPointerNative>(
          lib, 'glfwSetWindowUserPointer')
      .asFunction<GlfwSetWindowUserPointer>();
  glfwGetWindowUserPointer = loadFunction<GlfwGetWindowUserPointerNative>(
          lib, 'glfwGetWindowUserPointer')
      .asFunction<GlfwGetWindowUserPointer>();
  glfwSetWindowPosCallback = loadFunction<GlfwSetWindowPosCallbackNative>(
          lib, 'glfwSetWindowPosCallback')
      .asFunction<GlfwSetWindowPosCallback>();
  glfwSetWindowSizeCallback = loadFunction<GlfwSetWindowSizeCallbackNative>(
          lib, 'glfwSetWindowSizeCallback')
      .asFunction<GlfwSetWindowSizeCallback>();
  glfwSetWindowCloseCallback = loadFunction<GlfwSetWindowCloseCallbackNative>(
          lib, 'glfwSetWindowCloseCallback')
      .asFunction<GlfwSetWindowCloseCallback>();
  glfwSetWindowRefreshCallback =
      loadFunction<GlfwSetWindowRefreshCallbackNative>(
              lib, 'glfwSetWindowRefreshCallback')
          .asFunction<GlfwSetWindowRefreshCallback>();
  glfwSetWindowFocusCallback = loadFunction<GlfwSetWindowFocusCallbackNative>(
          lib, 'glfwSetWindowFocusCallback')
      .asFunction<GlfwSetWindowFocusCallback>();
  glfwSetWindowIconifyCallback =
      loadFunction<GlfwSetWindowIconifyCallbackNative>(
              lib, 'glfwSetWindowIconifyCallback')
          .asFunction<GlfwSetWindowIconifyCallback>();
  glfwSetWindowMaximizeCallback =
      loadFunction<GlfwSetWindowMaximizeCallbackNative>(
              lib, 'glfwSetWindowMaximizeCallback')
          .asFunction<GlfwSetWindowMaximizeCallback>();
  glfwSetFramebufferSizeCallback =
      loadFunction<GlfwSetFramebufferSizeCallbackNative>(
              lib, 'glfwSetFramebufferSizeCallback')
          .asFunction<GlfwSetFramebufferSizeCallback>();
  glfwSetWindowContentScaleCallback =
      loadFunction<GlfwSetWindowContentScaleCallbackNative>(
              lib, 'glfwSetWindowContentScaleCallback')
          .asFunction<GlfwSetWindowContentScaleCallback>();
  glfwPollEvents = loadFunction<GlfwPollEventsNative>(lib, 'glfwPollEvents')
      .asFunction<GlfwPollEvents>();
  glfwWaitEvents = loadFunction<GlfwWaitEventsNative>(lib, 'glfwWaitEvents')
      .asFunction<GlfwWaitEvents>();
  glfwWaitEventsTimeout =
      loadFunction<GlfwWaitEventsTimeoutNative>(lib, 'glfwWaitEventsTimeout')
          .asFunction<GlfwWaitEventsTimeout>();
  glfwPostEmptyEvent =
      loadFunction<GlfwPostEmptyEventNative>(lib, 'glfwPostEmptyEvent')
          .asFunction<GlfwPostEmptyEvent>();
  glfwGetInputMode =
      loadFunction<GlfwGetInputModeNative>(lib, 'glfwGetInputMode')
          .asFunction<GlfwGetInputMode>();
  glfwSetInputMode =
      loadFunction<GlfwSetInputModeNative>(lib, 'glfwSetInputMode')
          .asFunction<GlfwSetInputMode>();
  glfwRawMouseMotionSupported = loadFunction<GlfwRawMouseMotionSupportedNative>(
          lib, 'glfwRawMouseMotionSupported')
      .asFunction<GlfwRawMouseMotionSupported>();
  glfwGetKeyName = loadFunction<GlfwGetKeyNameNative>(lib, 'glfwGetKeyName')
      .asFunction<GlfwGetKeyName>();
  glfwGetKeyScancode =
      loadFunction<GlfwGetKeyScancodeNative>(lib, 'glfwGetKeyScancode')
          .asFunction<GlfwGetKeyScancode>();
  glfwGetKey = loadFunction<GlfwGetKeyNative>(lib, 'glfwGetKey')
      .asFunction<GlfwGetKey>();
  glfwGetMouseButton =
      loadFunction<GlfwGetMouseButtonNative>(lib, 'glfwGetMouseButton')
          .asFunction<GlfwGetMouseButton>();
  glfwGetCursorPos =
      loadFunction<GlfwGetCursorPosNative>(lib, 'glfwGetCursorPos')
          .asFunction<GlfwGetCursorPos>();
  glfwSetCursorPos =
      loadFunction<GlfwSetCursorPosNative>(lib, 'glfwSetCursorPos')
          .asFunction<GlfwSetCursorPos>();
  glfwCreateCursor =
      loadFunction<GlfwCreateCursorNative>(lib, 'glfwCreateCursor')
          .asFunction<GlfwCreateCursor>();
  glfwCreateStandardCursor = loadFunction<GlfwCreateStandardCursorNative>(
          lib, 'glfwCreateStandardCursor')
      .asFunction<GlfwCreateStandardCursor>();
  glfwDestroyCursor =
      loadFunction<GlfwDestroyCursorNative>(lib, 'glfwDestroyCursor')
          .asFunction<GlfwDestroyCursor>();
  glfwSetCursor = loadFunction<GlfwSetCursorNative>(lib, 'glfwSetCursor')
      .asFunction<GlfwSetCursor>();
  glfwSetKeyCallback =
      loadFunction<GlfwSetKeyCallbackNative>(lib, 'glfwSetKeyCallback')
          .asFunction<GlfwSetKeyCallback>();
  glfwSetCharCallback =
      loadFunction<GlfwSetCharCallbackNative>(lib, 'glfwSetCharCallback')
          .asFunction<GlfwSetCharCallback>();
  glfwSetCharModsCallback = loadFunction<GlfwSetCharModsCallbackNative>(
          lib, 'glfwSetCharModsCallback')
      .asFunction<GlfwSetCharModsCallback>();
  glfwSetMouseButtonCallback = loadFunction<GlfwSetMouseButtonCallbackNative>(
          lib, 'glfwSetMouseButtonCallback')
      .asFunction<GlfwSetMouseButtonCallback>();
  glfwSetCursorPosCallback = loadFunction<GlfwSetCursorPosCallbackNative>(
          lib, 'glfwSetCursorPosCallback')
      .asFunction<GlfwSetCursorPosCallback>();
  glfwSetCursorEnterCallback = loadFunction<GlfwSetCursorEnterCallbackNative>(
          lib, 'glfwSetCursorEnterCallback')
      .asFunction<GlfwSetCursorEnterCallback>();
  glfwSetScrollCallback =
      loadFunction<GlfwSetScrollCallbackNative>(lib, 'glfwSetScrollCallback')
          .asFunction<GlfwSetScrollCallback>();
  glfwSetDropCallback =
      loadFunction<GlfwSetDropCallbackNative>(lib, 'glfwSetDropCallback')
          .asFunction<GlfwSetDropCallback>();
  glfwJoystickPresent =
      loadFunction<GlfwJoystickPresentNative>(lib, 'glfwJoystickPresent')
          .asFunction<GlfwJoystickPresent>();
  glfwGetJoystickAxes =
      loadFunction<GlfwGetJoystickAxesNative>(lib, 'glfwGetJoystickAxes')
          .asFunction<GlfwGetJoystickAxes>();
  glfwGetJoystickButtons =
      loadFunction<GlfwGetJoystickButtonsNative>(lib, 'glfwGetJoystickButtons')
          .asFunction<GlfwGetJoystickButtons>();
  glfwGetJoystickHats =
      loadFunction<GlfwGetJoystickHatsNative>(lib, 'glfwGetJoystickHats')
          .asFunction<GlfwGetJoystickHats>();
  glfwGetJoystickName =
      loadFunction<GlfwGetJoystickNameNative>(lib, 'glfwGetJoystickName')
          .asFunction<GlfwGetJoystickName>();
  glfwGetJoystickGUID =
      loadFunction<GlfwGetJoystickGUIDNative>(lib, 'glfwGetJoystickGUID')
          .asFunction<GlfwGetJoystickGUID>();
  glfwSetJoystickUserPointer = loadFunction<GlfwSetJoystickUserPointerNative>(
          lib, 'glfwSetJoystickUserPointer')
      .asFunction<GlfwSetJoystickUserPointer>();
  glfwGetJoystickUserPointer = loadFunction<GlfwGetJoystickUserPointerNative>(
          lib, 'glfwGetJoystickUserPointer')
      .asFunction<GlfwGetJoystickUserPointer>();
  glfwJoystickIsGamepad =
      loadFunction<GlfwJoystickIsGamepadNative>(lib, 'glfwJoystickIsGamepad')
          .asFunction<GlfwJoystickIsGamepad>();
  glfwSetJoystickCallback = loadFunction<GlfwSetJoystickCallbackNative>(
          lib, 'glfwSetJoystickCallback')
      .asFunction<GlfwSetJoystickCallback>();
  glfwUpdateGamepadMappings = loadFunction<GlfwUpdateGamepadMappingsNative>(
          lib, 'glfwUpdateGamepadMappings')
      .asFunction<GlfwUpdateGamepadMappings>();
  glfwGetGamepadName =
      loadFunction<GlfwGetGamepadNameNative>(lib, 'glfwGetGamepadName')
          .asFunction<GlfwGetGamepadName>();
  glfwGetGamepadState =
      loadFunction<GlfwGetGamepadStateNative>(lib, 'glfwGetGamepadState')
          .asFunction<GlfwGetGamepadState>();
  glfwSetClipboardString =
      loadFunction<GlfwSetClipboardStringNative>(lib, 'glfwSetClipboardString')
          .asFunction<GlfwSetClipboardString>();
  glfwGetClipboardString =
      loadFunction<GlfwGetClipboardStringNative>(lib, 'glfwGetClipboardString')
          .asFunction<GlfwGetClipboardString>();
  glfwGetTime = loadFunction<GlfwGetTimeNative>(lib, 'glfwGetTime')
      .asFunction<GlfwGetTime>();
  glfwSetTime = loadFunction<GlfwSetTimeNative>(lib, 'glfwSetTime')
      .asFunction<GlfwSetTime>();
  glfwGetTimerValue =
      loadFunction<GlfwGetTimerValueNative>(lib, 'glfwGetTimerValue')
          .asFunction<GlfwGetTimerValue>();
  glfwGetTimerFrequency =
      loadFunction<GlfwGetTimerFrequencyNative>(lib, 'glfwGetTimerFrequency')
          .asFunction<GlfwGetTimerFrequency>();
  glfwMakeContextCurrent =
      loadFunction<GlfwMakeContextCurrentNative>(lib, 'glfwMakeContextCurrent')
          .asFunction<GlfwMakeContextCurrent>();
  glfwGetCurrentContext =
      loadFunction<GlfwGetCurrentContextNative>(lib, 'glfwGetCurrentContext')
          .asFunction<GlfwGetCurrentContext>();
  glfwSwapBuffers = loadFunction<GlfwSwapBuffersNative>(lib, 'glfwSwapBuffers')
      .asFunction<GlfwSwapBuffers>();
  glfwSwapInterval =
      loadFunction<GlfwSwapIntervalNative>(lib, 'glfwSwapInterval')
          .asFunction<GlfwSwapInterval>();
  glfwExtensionSupported =
      loadFunction<GlfwExtensionSupportedNative>(lib, 'glfwExtensionSupported')
          .asFunction<GlfwExtensionSupported>();
  glfwGetProcAddress =
      loadFunction<GlfwGetProcAddressNative>(lib, 'glfwGetProcAddress')
          .asFunction<GlfwGetProcAddress>();
  glfwVulkanSupported =
      loadFunction<GlfwVulkanSupportedNative>(lib, 'glfwVulkanSupported')
          .asFunction<GlfwVulkanSupported>();
  glfwGetRequiredInstanceExtensions =
      loadFunction<GlfwGetRequiredInstanceExtensionsNative>(
              lib, 'glfwGetRequiredInstanceExtensions')
          .asFunction<GlfwGetRequiredInstanceExtensions>();
  glfwGetInstanceProcAddress = loadFunction<GlfwGetInstanceProcAddressNative>(
          lib, 'glfwGetInstanceProcAddress')
      .asFunction<GlfwGetInstanceProcAddress>();
  glfwGetPhysicalDevicePresentationSupport =
      loadFunction<GlfwGetPhysicalDevicePresentationSupportNative>(
              lib, 'glfwGetPhysicalDevicePresentationSupport')
          .asFunction<GlfwGetPhysicalDevicePresentationSupport>();
  glfwCreateWindowSurface = loadFunction<GlfwCreateWindowSurfaceNative>(
          lib, 'glfwCreateWindowSurface')
      .asFunction<GlfwCreateWindowSurface>();
}
